// Sample program for use with Strmwdm.sys
// Copyright (c) 2001 Sangoma Technologies Inc.
// Target: Win32 Console

#include <windows.h>
#include <winioctl.h>
#include <stdio.h>
#include <conio.h>
#include "sangstrm.h"
#include "CHDLCAPI.H"


CHDLC_MAILBOX_STRUCT * pcb;
UCHAR rxdata[15000];
UCHAR cbdata[4000];

ULONG frames_count=0;
ULONG blocks_count=0;

BOOLEAN Buff_mode = FALSE;

char *hellostring = "LET ME GO! I'VE BEEN FRAMED!";

UCHAR DoCommand(HANDLE drv, CHDLC_MAILBOX_STRUCT * pcb);
UCHAR DoWriteCommand(HANDLE drv, CHDLC_MAILBOX_STRUCT * pcb);
USHORT DoReadCommand(HANDLE drv, PUCHAR dat, ULONG maxl);
DWORD ThreadFunc(LPDWORD lpdwParam);
UCHAR DoStatusCommand(HANDLE drv, CHDLC_DATA_TX_STATUS_EL_STRUCT * frsi);
VOID ConfigureDriverCommand(HANDLE drv, DRV_CONFIG_INFO * DrvConfigInfo);

void main()
{
	DWORD ln;
	CHDLC_CONFIGURATION_STRUCT * strc;
	//COMMS_ERROR_STATS_STRUCT * errstr;

	CHDLC_DATA_TX_STATUS_EL_STRUCT statinfo;
	DRV_CONFIG_INFO DrvConfigInfo;

    DWORD dwThreadId, dwThrdParam = 1; 
    HANDLE hThread; 
	HANDLE drv;
	char c;

	frames_count = 0;
	blocks_count = 0;
	
	pcb = (CHDLC_MAILBOX_STRUCT *)cbdata;

	// Open device number 0
	drv = CreateFile("\\\\.\\SANGSTRM0", GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE,
					 (LPSECURITY_ATTRIBUTES)NULL, OPEN_EXISTING, FILE_FLAG_NO_BUFFERING | FILE_FLAG_WRITE_THROUGH,
					 (HANDLE)NULL);

    if (drv == INVALID_HANDLE_VALUE)
	{
		printf("Unable to open SANGSTRM0!\n");
		return;
	}

	// clear the configuration data area
	memset(cbdata, 0, sizeof(cbdata));

    // set up for a global configuration
	strc = (CHDLC_CONFIGURATION_STRUCT *)pcb->data;

	pcb->command = SET_CHDLC_CONFIGURATION;

	pcb->buffer_length = sizeof(CHDLC_CONFIGURATION_STRUCT);
	
	strc->baud_rate = 56000;			// 56 kbps

	printf("\nClock: 0. External, 1. 56 kbps, 2. 1600 kbps, 3. 2750 kbps? ");
	c = getche();
	if (c == '0') strc->baud_rate = 0;
	if (c == '2') strc->baud_rate = 1600000;
	if (c == '3') strc->baud_rate = PRI_MAX_BAUD_RATE_S514;

	printf("\nConfigure for 'r's-232 or 'v'.35? ");

	if (getche() == 'r')
		strc->line_config_options = INTERFACE_LEVEL_RS232;
	else
		strc->line_config_options = INTERFACE_LEVEL_V35;
	printf("\n");

	strc->CHDLC_protocol_options = HDLC_STREAMING_MODE;	

	strc->percent_data_buffer_for_Tx = 50;

	strc->max_CHDLC_data_field_length = 1500;

	printf("Performing SET_CHDLC_CONFIGURATION\n");

	// perform the command
	DoCommand(drv, pcb);

	// if bad return_code don't continue, find what's wrong.
	printf("Rcode = %02X, blength = %u\n", pcb->return_code, pcb->buffer_length);
	for (ln=0; ln < (DWORD)pcb->buffer_length; ln++)
		printf("%02X ", pcb->data[ln]);
	printf("\n");

	printf("To configure driver in buffered mode press 'b' in nonbuffered mode press 'n'\n");
	c=getch();

	DrvConfigInfo.return_code = 99;
	if (c == 'b')
	{
		DrvConfigInfo.buffer_size = 40000;//Each Rx buffer will be of 40000/4 (NO_DRVR_RX_BFRS) bytes long.
		ConfigureDriverCommand(drv, &DrvConfigInfo);
		printf("ConfigureDriverCommand rc = %d\n", DrvConfigInfo.return_code);
		// display the return code - this command returns the buffer allocation info.
		// if bad return_code don't continue, find what's wrong.

		switch(DrvConfigInfo.return_code)
		{
		case COMMAND_PERFORMED_SUCCESSFULLY:
			printf("Command performed successfully\n");
			Buff_mode = TRUE;
			break;

		case BUFFER_ALLOCATION_FAILED:
			printf("Can't allocate buffer of requiered size\n");
			break;
		case DO_SET_CHDLC_CONFIGURATION:
			printf("SET_CHDLC_CONFIGURATION_DONE wasn't done\n");
			break;
		case DO_DISABLE_CHDLC_COMMUNICATIONS:
			printf("DISABLE_CHDLC_COMMUNICATIONS wasn't done\n");
			break;
		case INVALID_TOTAL_RX_BUFFER_SIZE:
			printf("SIZEOF_RX_BFR_LGTH_IND+sizeof(CHDLC_DATA_RX_STATUS_EL_STRUCT)+strc->max_CHDLC_data_field_length+NUMBER_OF_CRC_BYTES\n\twon't fit into buffer_size/NO_DRVR_RX_BFRS.\n");
			break;
		case BUFF_MODE_SET_INTERRUPT_TRIGS_FAILED:
			printf("BUFF_MODE_SET_INTERRUPT_TRIGS_FAILED\n");
		default:
			printf("ConfigureDriverCommand wasn't executed properly\n");
			break;
		}
		printf("\nPress any key to continue.\n");
		getch();
	}



	// enable the transmitter and receiver (check the return_code!).
	pcb->command = ENABLE_CHDLC_COMMUNICATIONS;
	pcb->buffer_length = 0;

	printf("Performing ENABLE_CHDLC_COMMUNICATIONS\n");

	DoCommand(drv, pcb);

	// start a read thread
    hThread = CreateThread( 
        NULL,                        /* no security attributes        */ 
        0,                           /* use default stack size        */ 
        (LPTHREAD_START_ROUTINE) ThreadFunc, /* thread function       */ 
        &dwThrdParam,                /* argument to thread function   */ 
        0,                           /* use default creation flags    */ 
        &dwThreadId);                /* returns the thread identifier */ 



	// loop around waiting for user to request the transmission of a frame
	// or to look at some status bytes
	do{
		printf("\nPress 'q' to quit or 'f' to get RX frames_count and RX blocks_count or\n\t's' for statistics or any key to send hello.\n");
		c=getch();
	
		printf("\n");

		if (c == 's')
		{
			// print TX status information
			printf("DoStatusCommand rc = %d\n", DoStatusCommand(drv, &statinfo));
			printf("opp_flag: 0x%02X\n", statinfo.opp_flag);
			printf("\n");
		}
		if(c == 'f')
		{
			printf("blocks_count:%ld\n", blocks_count);
			printf("frames_count:%ld\n", frames_count);
		}
		else if(c != 'q')
		{
			//send a frame
			pcb->buffer_length = strlen(hellostring);
			strcpy(pcb->data, hellostring);
			printf("Doing write right now...\n");
			// queue for transmission
			DoWriteCommand(drv, pcb);
			// if the return code isn't zero, it didn't get queued
			printf("Write rcode = %02X.\n", pcb->return_code);
		}
	} while (c != 'q');

	printf("\nPress any key to disable comms.\n");
	getch();

	// turn off the receiver - this also cancels any pending read commands
	do {
		pcb->command = DISABLE_CHDLC_COMMUNICATIONS;
		pcb->buffer_length = 0;
		DoCommand(drv, pcb);
		printf("Disable comms rcode = %02X.\n", pcb->return_code);
	} while (pcb->return_code);

	printf("WRITE:Press any key to close device...\n");
	getch();

	// close the open handle
	CloseHandle(drv);
}

// perform a standard command
UCHAR DoCommand(HANDLE drv, CHDLC_MAILBOX_STRUCT * pcb)
{
	DWORD ln;

	if (DeviceIoControl(
		drv,
		IoctlCodeCblockCommand,
		(LPVOID)pcb,
		(ULONG)pcb->buffer_length + 16L,
		(LPVOID)pcb,
		sizeof(cbdata),
		(LPDWORD)(&ln),
		(LPOVERLAPPED)NULL
		) == FALSE)
		pcb->return_code = 0x7d;		// STATUS_UNSUCCESSFUL
	return(pcb->return_code);
}

// transmit a frame
UCHAR DoWriteCommand(HANDLE drv, CHDLC_MAILBOX_STRUCT * pcb)
{
	DWORD ln;

	if (DeviceIoControl(
		drv,
		IoctlCodeWriteCommand,
		(LPVOID)pcb,
		(ULONG)pcb->buffer_length + 16L,
		(LPVOID)pcb,
		sizeof(cbdata),
		(LPDWORD)(&ln),
		(LPOVERLAPPED)NULL
		) == FALSE)
		pcb->return_code = 0x7d;		// STATUS_UNSUCCESSFUL
	return(pcb->return_code);
}

// do blocking read command
// received frame is stored in user buffer on return
USHORT DoReadCommand(HANDLE drv, PUCHAR dat, ULONG maxl)
{
	DWORD ln;
	USHORT rc=0;

	if (DeviceIoControl(
		drv,
		IoctlCodeReadCommand,
		(LPVOID)NULL,
		0L,
		(LPVOID)dat,
		maxl,
		(LPDWORD)(&ln),
		(LPOVERLAPPED)NULL
		) == FALSE)
		rc = 1;				// STATUS_UNSUCCESSFUL

	return rc;
}

// read some status information off the board
UCHAR DoStatusCommand(HANDLE drv, CHDLC_DATA_TX_STATUS_EL_STRUCT * frsi)
{
	DWORD ln;

	if (DeviceIoControl(
		drv,
		IoctlCodeStatusCommand,
		NULL,
		0,
		(LPVOID)frsi,
		sizeof(CHDLC_DATA_TX_STATUS_EL_STRUCT),
		(LPDWORD)(&ln),
		(LPOVERLAPPED)NULL
		) == FALSE) return(0);	// STATUS_UNSUCCESSFUL
		
	return(1);
}

VOID ConfigureDriverCommand(HANDLE drv, DRV_CONFIG_INFO * DrvConfigInfo)
{
	DWORD ln;

	DeviceIoControl(
		drv,
		IoctlDriverConfigCommand,
		(LPVOID)DrvConfigInfo,
		sizeof(DRV_CONFIG_INFO),
		(LPVOID)DrvConfigInfo,
		sizeof(DRV_CONFIG_INFO),
		(LPDWORD)(&ln),
		(LPOVERLAPPED)NULL);
}

// read thread
DWORD ThreadFunc(LPDWORD lpdwParam)
{ 
	USHORT datlen;
	DWORD ln;
	HANDLE drv;
	PSTREAMING_READ_INFO pri;
	ULONG lgth_Rx_data = 0;	
	ULONG shift;

    printf("\nThreadFunc:  thread parameter=%d\n", *lpdwParam); 

	// open another handle strictly for reading
	drv = CreateFile("\\\\.\\SANGSTRM0", GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE,
					 (LPSECURITY_ATTRIBUTES)NULL, OPEN_EXISTING, FILE_FLAG_NO_BUFFERING | FILE_FLAG_WRITE_THROUGH,
					 (HANDLE)NULL);

    if (drv == INVALID_HANDLE_VALUE)
	{
		printf("\nUnable to open SANGSTRM0!\n");
		return(0);
	}

	if(Buff_mode == TRUE)
	{

	//
	// Multiple frames may be received in a single block passed to the application. Each block is of the following format:
	//    First ULONG (four bytes) in the block is the total length of the received block.
	//    Thereafter, each frame is decoded as per the original code, i.e., each frame starts with a
	//    CHDLC_DATA_RX_STATUS_EL_STRUCT (16 bytes), followed by the actual data and 2 CRC bytes.
	//

		// keep reading forever until the attempt fails
		while (DoReadCommand(drv, rxdata, 15000) == 0)
		{
			printf("\nBuffered mode:Waiting to read something\n");
			//First ULONG in the block defines the block length, must be greater then 4.
			lgth_Rx_data = *(ULONG *)&rxdata[0x00];
			if(lgth_Rx_data <= 4)
			{
				printf("lngth_Rx_data :%d\n", lgth_Rx_data);
				break;
			}
			printf("\nRx block of length %u bytes\n", lgth_Rx_data);

			blocks_count++;
			//Move to the first frame in the block
			shift = 4;
			while(shift < lgth_Rx_data)
			{
				// a frame was received - dump it without first 16 header bytes
				pri = (PSTREAMING_READ_INFO)&rxdata[shift];
				datlen = pri->FrameLength;//includes 2 CRC bytes
				printf("\tframe datlen = %d\n", datlen);
			
				//Minus two CRC bytes
				for (ln=0; ln < (DWORD)datlen-2; ln++)
					printf("%C ", rxdata[shift+ln+16]);
				printf("\n");

				frames_count++;

				//Move to the next frame in the block
				shift = shift + 16 + pri->FrameLength;
			}
		}
	}
	else
	{
		while (DoReadCommand(drv, rxdata, 15000) == 0)
		{
			printf("\nNonBuffered mode:Waiting to read something...\n");
			//use our special buffer at rxdata to hold received frame
			pri = (PSTREAMING_READ_INFO)rxdata;

			// a frame was received - dump it without first 16 header bytes
			datlen = pri->FrameLength;
			//Minus two CRC 
			for (ln=0; ln < (DWORD)datlen-2; ln++)
				printf("%C ", rxdata[ln+16]);
			printf("\n");
			if(pri->MiscBits != 0)
			{
				printf("MBits=0x%02X\n", pri->MiscBits);
			}
		}
	}



	// if the read command returned but with no frame, either
	// DISABLE_CHDLC_COMMUNICATIONS was done or all open device handles were closed
	printf("\nREAD:Thread is closing the driver...\n");
	CloseHandle(drv);
	printf("READ:Thread is terminating...\n");
    return 0; 
}
 
